local snail = false
local RESTORE_TIME= 340*TICRATE

local CV_TO_CHANGE={
    {cvname="triplesneaker", value="off"},
    {cvname="sneaker", value= "off"},
    {cvname="grow", value= "off"},
    {cvname="invincibility", value= "off"},
    {cvname="rocketsneaker", value= "off"},
	{cvname="hyudoro", value= "off"},
	{cvname="antigrief", value= "off"}
}

addHook("MapLoad", function(mapid)
  snail = G_BuildMapName(mapid) == "MAPFE"
end)

addHook("NetVars", function(net)
  snail = net($)
end)


local function countPlayers()
    local c = 0
    local active

    for player in players.iterate do
        if not player.spectator then
            c = c + 1
            active = player
        end
    end

    return c, active
end

local CV_Backups= nil

local function backupAndChangeCV()	
    if not CV_Backups then
        CV_Backups= {}
    end

    for i=1,#CV_TO_CHANGE do
        local obj= CV_TO_CHANGE[i]
        local cv= CV_FindVar(obj.cvname)
        if not cv then
            print("ERROR - Counldn't access CVar '"..obj.cvname.."'...")
            continue
        end

        CV_Backups[obj.cvname]= cv.value

        COM_BufInsertText(server,obj.cvname.." "..obj.value)
    end
end

local function restoreCV()
 
    if not CV_Backups then return end

    for cvname,value in pairs(CV_Backups) do
        local cv= CV_FindVar(cvname)
        if not cv then
            print("ERROR - Counldn't restore CVar '"..cvname.."'...")
            continue
        end

        COM_BufInsertText(server,cvname.." "..value)
    end

    CV_Backups= nil
end


addHook("ThinkFrame", function()
	if not snail then return end
	
	local active_count
    local player
    active_count, player = countPlayers()
		
    if leveltime==0 then
        restoreCV()
    end
	
    if active_count == 1 then return end
	
    if snail then
        if leveltime==1 then
            backupAndChangeCV()
        end
        if leveltime==RESTORE_TIME then
            restoreCV()
        end
    end
end)

addHook("IntermissionThinker", restoreCV)
addHook("VoteThinker", restoreCV)
